Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 85270 - dlsym is not thread safe
Summary: dlsym is not thread safe
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Red Hat Public Beta
Classification: Retired
Component: glibc
Version: phoebe
Hardware: i686
OS: Linux
high
high
Target Milestone: ---
Assignee: Ulrich Drepper
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks: 79578
TreeView+ depends on / blocked
 
Reported: 2003-02-27 04:26 UTC by Ulrich Drepper
Modified: 2016-11-24 15:19 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2003-02-28 02:56:05 UTC


Attachments (Terms of Use)
Test program showing the crash (deleted)
2003-02-27 04:27 UTC, Ulrich Drepper
no flags Details
Patch to fix the problem (deleted)
2003-02-27 04:28 UTC, Ulrich Drepper
no flags Details | Diff

Description Ulrich Drepper 2003-02-27 04:26:20 UTC
Description of problem:

Using dlsym in different threads at the same time can and will corrupt the stack
and cause a problem to crash if the dlsym() lookup failed.


Version-Release number of selected component (if applicable):

glibc-2.3.2-2

How reproducible:

Run attached program.  Test code by Hui Huang from Sun.


Steps to Reproduce:
1. run the program, perhaps multiple times
2.
3.
    
Actual results:

crashes

Expected results:

no crash, no output

Additional info:

Comment 1 Ulrich Drepper 2003-02-27 04:27:36 UTC
Created attachment 90392 [details]
Test program showing the crash

Test program written by Hui Huang.

Comment 2 Ulrich Drepper 2003-02-27 04:28:44 UTC
Created attachment 90393 [details]
Patch to fix the problem

Patc relative to official CVS sources as of 2002-02-26T20:20:00-0800.

Comment 3 Ulrich Drepper 2003-02-27 04:56:18 UTC
Waiting for fix to show up in rawhide.

Comment 4 Bill Nottingham 2003-02-27 17:39:22 UTC
Fixed in 2.3.2-5.

Comment 5 Jay Turner 2003-02-28 02:56:05 UTC
Fix confirmed in latest packages.


Note You need to log in before you can comment on or make changes to this bug.